Index: uspace/app/bdsh/cmds/modules/mount/mount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mount/mount.c	(revision 6e5562a50605c74483afabb2b90fff85b7f3b5cc)
+++ uspace/app/bdsh/cmds/modules/mount/mount.c	(revision 80743a1b2ba5306f70559161509a3376fa381a08)
@@ -147,8 +147,8 @@
 		mopts = t_argv[4];
 
-	rc = mount(t_argv[1], t_argv[2], dev, mopts, 0, instance);
+	rc = vfs_mount_path(t_argv[2], t_argv[1], dev, mopts, 0, instance);
 	if (rc != EOK) {
 		printf("Unable to mount %s filesystem to %s on %s (rc=%s)\n",
-		    t_argv[1], t_argv[2], t_argv[3], str_error(rc));
+		    t_argv[2], t_argv[1], t_argv[3], str_error(rc));
 		return CMD_FAILURE;
 	}
Index: uspace/app/bdsh/cmds/modules/unmount/unmount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/unmount/unmount.c	(revision 6e5562a50605c74483afabb2b90fff85b7f3b5cc)
+++ uspace/app/bdsh/cmds/modules/unmount/unmount.c	(revision 80743a1b2ba5306f70559161509a3376fa381a08)
@@ -66,5 +66,5 @@
 	}
 
-	rc = unmount(argv[1]);
+	rc = vfs_unmount_path(argv[1]);
 	if (rc != EOK) {
 		printf("Unable to unmount %s (rc=%d)\n", argv[1], rc);
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 6e5562a50605c74483afabb2b90fff85b7f3b5cc)
+++ uspace/app/init/init.c	(revision 80743a1b2ba5306f70559161509a3376fa381a08)
@@ -127,5 +127,5 @@
 		opts = "restore";
 	
-	int rc = mount(fstype, ROOT_MOUNT_POINT, ROOT_DEVICE, opts,
+	int rc = vfs_mount_path(ROOT_MOUNT_POINT, fstype, ROOT_DEVICE, opts,
 	    IPC_FLAG_BLOCKING, 0);
 	if (rc == EOK)
@@ -146,5 +146,5 @@
 static bool mount_locfs(void)
 {
-	int rc = mount(LOCFS_FS_TYPE, LOCFS_MOUNT_POINT, "", "",
+	int rc = vfs_mount_path(LOCFS_MOUNT_POINT, LOCFS_FS_TYPE, "", "",
 	    IPC_FLAG_BLOCKING, 0);
 	return mount_report("Location service filesystem", LOCFS_MOUNT_POINT,
@@ -302,5 +302,5 @@
 static bool mount_tmpfs(void)
 {
-	int rc = mount(TMPFS_FS_TYPE, TMPFS_MOUNT_POINT, "", "", 0, 0);
+	int rc = vfs_mount_path(TMPFS_MOUNT_POINT, TMPFS_FS_TYPE, "", "", 0, 0);
 	return mount_report("Temporary filesystem", TMPFS_MOUNT_POINT,
 	    TMPFS_FS_TYPE, NULL, rc);
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision 6e5562a50605c74483afabb2b90fff85b7f3b5cc)
+++ uspace/app/sysinst/sysinst.c	(revision 80743a1b2ba5306f70559161509a3376fa381a08)
@@ -179,5 +179,5 @@
 
 	printf("sysinst_fs_mount(): mount filesystem\n");
-	rc = mount(FS_TYPE, MOUNT_POINT, dev, "", 0, 0);
+	rc = vfs_mount_path(MOUNT_POINT, FS_TYPE, dev, "", 0, 0);
 	if (rc != EOK)
 		return rc;
@@ -218,5 +218,5 @@
 
 	printf("sysinst_copy_boot_files(): mount CD filesystem\n");
-	rc = mount(CD_FS_TYPE, CD_MOUNT_POINT, CD_DEV, "", 0, 0);
+	rc = vfs_mount_path(CD_MOUNT_POINT, CD_FS_TYPE, CD_DEV, "", 0, 0);
 	if (rc != EOK)
 		return rc;
@@ -228,5 +228,5 @@
 
 	printf("sysinst_copy_boot_files(): unmount %s\n", MOUNT_POINT);
-	rc = unmount(MOUNT_POINT);
+	rc = vfs_unmount_path(MOUNT_POINT);
 	if (rc != EOK)
 		return rc;
Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 6e5562a50605c74483afabb2b90fff85b7f3b5cc)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision 80743a1b2ba5306f70559161509a3376fa381a08)
@@ -255,5 +255,5 @@
 }
 
-int mount(const char *fs_name, const char *mp, const char *fqsn,
+int vfs_mount_path(const char *mp, const char *fs_name, const char *fqsn,
     const char *opts, unsigned int flags, unsigned int instance)
 {
@@ -342,5 +342,5 @@
 }
 
-int unmount(const char *mpp)
+int vfs_unmount_path(const char *mpp)
 {
 	int mp = vfs_lookup(mpp, WALK_MOUNT_POINT | WALK_DIRECTORY);
Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision 6e5562a50605c74483afabb2b90fff85b7f3b5cc)
+++ uspace/lib/c/include/vfs/vfs.h	(revision 80743a1b2ba5306f70559161509a3376fa381a08)
@@ -75,8 +75,4 @@
 extern char *vfs_absolutize(const char *, size_t *);
 
-extern int mount(const char *, const char *, const char *, const char *,
-    unsigned int, unsigned int);
-extern int unmount(const char *);
-
 extern int vfs_fhandle(FILE *, int *);
 
@@ -96,4 +92,8 @@
 extern int vfs_link(int, const char *, vfs_file_kind_t);
 extern int vfs_link_path(const char *, vfs_file_kind_t);
+extern int vfs_mount_path(const char *, const char *, const char *,
+    const char *, unsigned int, unsigned int);
+extern int vfs_mount(int, const char *, service_id_t, const char *, unsigned,
+    unsigned, int *);
 extern int vfs_resize(int, aoff64_t);
 extern int vfs_root(void);
@@ -106,7 +106,7 @@
 extern int vfs_unlink(int, const char *, int);
 extern int vfs_unlink_path(const char *);
+extern int vfs_unmount(int);
+extern int vfs_unmount_path(const char *);
 
-int vfs_mount(int, const char *, service_id_t, const char *, unsigned, unsigned, int *);
-int vfs_unmount(int);
 
 #endif