Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ boot/arch/amd64/Makefile.inc	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -49,5 +49,5 @@
 	$(USPACEDIR)/app/tester/tester \
 	$(USPACEDIR)/app/klog/klog \
-	$(USPACEDIR)/app/cli/cli \
+	$(USPACEDIR)/app/bdsh/bdsh \
 	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
 	$(USPACEDIR)/srv/fs/fat/fat
Index: boot/arch/arm32/loader/Makefile
===================================================================
--- boot/arch/arm32/loader/Makefile	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ boot/arch/arm32/loader/Makefile	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -102,5 +102,5 @@
 	$(USPACEDIR)/app/tester/tester \
 	$(USPACEDIR)/app/klog/klog \
-	$(USPACEDIR)/app/cli/cli
+	$(USPACEDIR)/app/bdsh/bdsh
 
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
Index: boot/arch/ia32/Makefile.inc
===================================================================
--- boot/arch/ia32/Makefile.inc	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ boot/arch/ia32/Makefile.inc	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -49,5 +49,4 @@
 	$(USPACEDIR)/app/tetris/tetris \
 	$(USPACEDIR)/app/tester/tester \
-	$(USPACEDIR)/app/cli/cli \
 	$(USPACEDIR)/app/klog/klog \
 	$(USPACEDIR)/app/bdsh/bdsh
Index: boot/arch/mips32/loader/Makefile
===================================================================
--- boot/arch/mips32/loader/Makefile	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ boot/arch/mips32/loader/Makefile	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -101,5 +101,5 @@
 	$(USPACEDIR)/app/tetris/tetris \
 	$(USPACEDIR)/app/tester/tester \
-	$(USPACEDIR)/app/cli/cli \
+	$(USPACEDIR)/app/bdsh/bdsh \
 	$(USPACEDIR)/app/klog/klog
 
Index: boot/arch/ppc32/loader/Makefile
===================================================================
--- boot/arch/ppc32/loader/Makefile	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ boot/arch/ppc32/loader/Makefile	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -97,5 +97,5 @@
 	$(USPACEDIR)/app/tester/tester \
 	$(USPACEDIR)/app/klog/klog \
-	$(USPACEDIR)/app/cli/cli
+	$(USPACEDIR)/app/bdsh/bdsh
 
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
Index: boot/arch/sparc64/loader/Makefile
===================================================================
--- boot/arch/sparc64/loader/Makefile	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ boot/arch/sparc64/loader/Makefile	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -99,5 +99,5 @@
 	$(USPACEDIR)/app/tetris/tetris \
 	$(USPACEDIR)/app/tester/tester \
-	$(USPACEDIR)/app/cli/cli \
+	$(USPACEDIR)/app/bdsh/bdsh \
 	$(USPACEDIR)/app/klog/klog
 
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ uspace/Makefile	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -49,5 +49,4 @@
 	app/tetris \
 	app/tester \
-	app/cli \
 	app/klog \
 	app/init \
Index: pace/app/cli/Makefile
===================================================================
--- uspace/app/cli/Makefile	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ 	(revision )
@@ -1,86 +1,0 @@
-#
-# Copyright (c) 2005 Martin Decky
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-# - Redistributions of source code must retain the above copyright
-#   notice, this list of conditions and the following disclaimer.
-# - Redistributions in binary form must reproduce the above copyright
-#   notice, this list of conditions and the following disclaimer in the
-#   documentation and/or other materials provided with the distribution.
-# - The name of the author may not be used to endorse or promote products
-#   derived from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
-# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
-# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
-# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
-# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
-# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
-# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-#
-
-include ../../../version
-include ../../Makefile.config
-
-## Setup toolchain
-#
-
-LIBC_PREFIX = ../../lib/libc
-SOFTINT_PREFIX = ../../lib/softint
-include $(LIBC_PREFIX)/Makefile.toolchain
-
-CFLAGS += -I../../srv/kbd/include
-
-LIBS = $(LIBC_PREFIX)/libc.a
-DEFS += -DRELEASE=\"$(RELEASE)\"
-
-ifdef REVISION
-	DEFS += "-DREVISION=\"$(REVISION)\""
-endif
-
-ifdef TIMESTAMP
-	DEFS += "-DTIMESTAMP=\"$(TIMESTAMP)\""
-endif
-
-## Sources
-#
-
-OUTPUT = cli
-SOURCES = \
-	cli.c
-
-OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
-
-.PHONY: all clean depend disasm
-
-all: $(OUTPUT) disasm
-
--include Makefile.depend
-
-clean:
-	-rm -f $(OUTPUT) $(OUTPUT).map $(OUTPUT).disasm Makefile.depend
-
-depend:
-	$(CC) $(DEFS) $(CFLAGS) -M $(SOURCES) > Makefile.depend
-
-$(OUTPUT): $(OBJECTS) $(LIBS)
-	$(LD) -T $(LIBC_PREFIX)/arch/$(ARCH)/_link.ld $(OBJECTS) $(LIBS) $(LFLAGS) -o $@ -Map $(OUTPUT).map
-
-disasm:
-	$(OBJDUMP) -d $(OUTPUT) >$(OUTPUT).disasm
-
-%.o: %.S
-	$(CC) $(DEFS) $(AFLAGS) $(CFLAGS) -D__ASM__ -c $< -o $@
-
-%.o: %.s
-	$(AS) $(AFLAGS) $< -o $@
-
-%.o: %.c
-	$(CC) $(DEFS) $(CFLAGS) -c $< -o $@
Index: pace/app/cli/cli.c
===================================================================
--- uspace/app/cli/cli.c	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ 	(revision )
@@ -1,125 +1,0 @@
-/*
- * Copyright (c) 2008 Jiri Svoboda
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup cli cli
- * @brief	Trivial command-line interface for running programs.
- * @{
- */ 
-/**
- * @file
- */
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <task.h>
-
-#define LINE_BUFFER_SIZE 128
-static char line_buffer[LINE_BUFFER_SIZE];
-
-#define MAX_ARGS 16
-static char *argv_buf[MAX_ARGS + 1];
-
-static void read_line(char *buffer, int n)
-{
-	char c;
-	int chars;
-
-	printf("> ");
-
-	chars = 0;
-	while (chars < n - 1) {
-		c = getchar();
-		if (c < 0) exit(0);
-		if (c == '\n') break;
-		if (c == '\b') {
-			if (chars > 0) {
-				putchar('\b');
-				--chars;
-			}
-			continue;
-		}
-		
-		putchar(c);
-		buffer[chars++] = c;
-	}
-
-	putchar('\n');
-	buffer[chars] = '\0';
-}
-
-static void program_run(void)
-{
-	char *p;
-	int n;
-
-	p = line_buffer;
-	n = 0;
-
-	while (n < MAX_ARGS) {
-		argv_buf[n++] = p;
-		p = strchr(p, ' ');
-		if (p == NULL) break;
-
-		*p++ = '\0';
-	}
-	argv_buf[n] = NULL;
-
-	printf("spawn task '%s' with %d args\n", argv_buf[0], n);
-	printf("args:");
-	int i;
-	for (i = 0; i < n; ++i) {
-		printf(" '%s'", argv_buf[i]);
-	}
-	printf("\n");
-
-	task_spawn(argv_buf[0], argv_buf);
-}
-
-
-int main(int argc, char *argv[])
-{
-	printf("This is CLI\n");
-
-	while (1) {
-		read_line(line_buffer, LINE_BUFFER_SIZE);
-		printf("'%s'\n", line_buffer);
-		if (strcmp(line_buffer, "exit") == 0)
-			break;
-		
-		if (line_buffer[0] != '\0')
-		program_run();
-	}
-
-	printf("Bye\n");
-	
-	return 0;
-}
-
-/** @}
- */
-
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision ab00d5a34f48fa0120df7cfe5146b032101ff9c4)
+++ uspace/app/init/init.c	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -99,8 +99,6 @@
 	info_print();
 	sleep(5);	// FIXME
-	bool has_tmpfs = false;
-	bool has_fat = false;
 	
-	if (!(has_tmpfs = mount_fs("tmpfs")) && !(has_fat = mount_fs("fat"))) {
+	if (!mount_fs("tmpfs") && !mount_fs("fat")) {
 		printf(NAME ": Exiting\n");
 		return -1;
@@ -115,16 +113,4 @@
 	version_print();
 	
-	/*
-	 * Spawn file system servers that were not loaded as init tasks.
-	 */
-	if (!has_fat)
-		spawn("/sbin/fat");
-	if (!has_tmpfs)
-		spawn("/sbin/tmpfs");
-		
-	spawn("/sbin/tetris");
-	spawn("/sbin/cli");
-	// FIXME: spawn("/sbin/tester");
-	spawn("/sbin/klog");
 	spawn("/sbin/bdsh");
 	