Index: uspace/app/fdisk/fdisk.c
===================================================================
--- uspace/app/fdisk/fdisk.c	(revision 460ea7ed2af9977b884414b68b2f7b94fa472cfd)
+++ uspace/app/fdisk/fdisk.c	(revision 84876aa4f80a43fe7bb9c01fbe376d900db1cbe4)
@@ -34,5 +34,5 @@
  */
 
-#include <cap.h>
+#include <capa.h>
 #include <errno.h>
 #include <fdisk.h>
@@ -136,7 +136,7 @@
 	nchoice_t *choice = NULL;
 	char *svcname = NULL;
-	cap_spec_t cap;
+	capa_spec_t capa;
 	fdisk_dev_info_t *sdev;
-	char *scap = NULL;
+	char *scapa = NULL;
 	char *dtext = NULL;
 	service_id_t svcid;
@@ -177,5 +177,5 @@
 		}
 
-		rc = fdisk_dev_info_capacity(info, &cap);
+		rc = fdisk_dev_info_capacity(info, &capa);
 		if (rc != EOK) {
 			printf("Error getting device capacity "
@@ -185,7 +185,7 @@
 		}
 
-		cap_simplify(&cap);
-
-		rc = cap_format(&cap, &scap);
+		capa_simplify(&capa);
+
+		rc = capa_format(&capa, &scapa);
 		if (rc != EOK) {
 			assert(rc == ENOMEM);
@@ -194,5 +194,5 @@
 		}
 
-		int ret = asprintf(&dtext, "%s (%s)", svcname, scap);
+		int ret = asprintf(&dtext, "%s (%s)", svcname, scapa);
 		if (ret < 0) {
 			rc = ENOMEM;
@@ -203,6 +203,6 @@
 		free(svcname);
 		svcname = NULL;
-		free(scap);
-		scap = NULL;
+		free(scapa);
+		scapa = NULL;
 
 		rc = nchoice_add(choice, dtext, info, 0);
@@ -261,5 +261,5 @@
 	free(dtext);
 	free(svcname);
-	free(scap);
+	free(scapa);
 	return rc;
 }
@@ -432,12 +432,12 @@
 	errno_t rc;
 	fdisk_part_spec_t pspec;
-	cap_spec_t cap;
-	cap_spec_t mcap;
+	capa_spec_t capa;
+	capa_spec_t mcapa;
 	vol_label_supp_t vlsupp;
 	vol_fstype_t fstype = 0;
 	tinput_t *tinput = NULL;
 	fdisk_spc_t spc;
-	char *scap;
-	char *smcap = NULL;
+	char *scapa;
+	char *smcapa = NULL;
 	char *label = NULL;
 	char *mountp = NULL;
@@ -448,5 +448,5 @@
 		spc = spc_pri;
 
-	rc = fdisk_part_get_max_avail(dev, spc, &mcap);
+	rc = fdisk_part_get_max_avail(dev, spc, &mcapa);
 	if (rc != EOK) {
 		rc = EIO;
@@ -454,7 +454,7 @@
 	}
 
-	cap_simplify(&mcap);
-
-	rc = cap_format(&mcap, &smcap);
+	capa_simplify(&mcapa);
+
+	rc = capa_format(&mcapa, &smcapa);
 	if (rc != EOK) {
 		rc = ENOMEM;
@@ -474,9 +474,9 @@
 	while (true) {
 		printf("Enter capacity of new partition.\n");
-		rc = tinput_read_i(tinput, smcap, &scap);
+		rc = tinput_read_i(tinput, smcapa, &scapa);
 		if (rc != EOK)
 			goto error;
 
-		rc = cap_parse(scap, &cap);
+		rc = capa_parse(scapa, &capa);
 		if (rc == EOK)
 			break;
@@ -485,6 +485,6 @@
 	tinput_destroy(tinput);
 	tinput = NULL;
-	free(smcap);
-	smcap = NULL;
+	free(smcapa);
+	smcapa = NULL;
 
 	if (pkind != lpk_extended) {
@@ -545,5 +545,5 @@
 
 	fdisk_pspec_init(&pspec);
-	pspec.capacity = cap;
+	pspec.capacity = capa;
 	pspec.pkind = pkind;
 	pspec.fstype = fstype;
@@ -561,5 +561,5 @@
 	return EOK;
 error:
-	free(smcap);
+	free(smcapa);
 	free(label);
 	free(mountp);
@@ -581,5 +581,5 @@
 	fdisk_part_t *part;
 	fdisk_part_info_t pinfo;
-	char *scap = NULL;
+	char *scapa = NULL;
 	char *spkind = NULL;
 	char *sfstype = NULL;
@@ -596,7 +596,7 @@
 		}
 
-		cap_simplify(&pinfo.capacity);
-
-		rc = cap_format(&pinfo.capacity, &scap);
+		capa_simplify(&pinfo.capacity);
+
+		rc = capa_format(&pinfo.capacity, &scapa);
 		if (rc != EOK) {
 			printf("Out of memory.\n");
@@ -623,5 +623,5 @@
 
 			int ret = asprintf(&sdesc, "%s %s, %s, %s", label,
-			    scap, spkind, sfstype);
+			    scapa, spkind, sfstype);
 			if (ret < 0) {
 				rc = ENOMEM;
@@ -630,5 +630,5 @@
 
 		} else {
-			int ret = asprintf(&sdesc, "%s, %s", scap, spkind);
+			int ret = asprintf(&sdesc, "%s, %s", scapa, spkind);
 			if (ret < 0) {
 				rc = ENOMEM;
@@ -644,6 +644,6 @@
 		}
 
-		free(scap);
-		scap = NULL;
+		free(scapa);
+		scapa = NULL;
 		free(spkind);
 		spkind = NULL;
@@ -658,5 +658,5 @@
 	return EOK;
 error:
-	free(scap);
+	free(scapa);
 	free(spkind);
 	free(sfstype);
@@ -907,11 +907,11 @@
 	fdisk_part_t *part;
 	fdisk_part_info_t pinfo;
-	cap_spec_t cap;
-	cap_spec_t mcap;
+	capa_spec_t capa;
+	capa_spec_t mcapa;
 	fdisk_dev_flags_t dflags;
 	char *sltype = NULL;
-	char *sdcap = NULL;
-	char *scap = NULL;
-	char *smcap = NULL;
+	char *sdcapa = NULL;
+	char *scapa = NULL;
+	char *smcapa = NULL;
 	char *sfstype = NULL;
 	char *svcname = NULL;
@@ -936,5 +936,5 @@
 	}
 
-	rc = fdisk_dev_capacity(dev, &cap);
+	rc = fdisk_dev_capacity(dev, &capa);
 	if (rc != EOK) {
 		printf("Error getting device capacity.\n");
@@ -942,7 +942,7 @@
 	}
 
-	cap_simplify(&cap);
-
-	rc = cap_format(&cap, &sdcap);
+	capa_simplify(&capa);
+
+	rc = capa_format(&capa, &sdcapa);
 	if (rc != EOK) {
 		printf("Out of memory.\n");
@@ -958,7 +958,7 @@
 	fdisk_dev_get_flags(dev, &dflags);
 
-	printf("Device: %s (%s)\n", svcname, sdcap);
-	free(sdcap);
-	sdcap = NULL;
+	printf("Device: %s (%s)\n", svcname, sdcapa);
+	free(sdcapa);
+	sdcapa = NULL;
 
 	rc = fdisk_label_get_info(dev, &linfo);
@@ -996,7 +996,7 @@
 		}
 
-		cap_simplify(&pinfo.capacity);
-
-		rc = cap_format(&pinfo.capacity, &scap);
+		capa_simplify(&pinfo.capacity);
+
+		rc = capa_format(&pinfo.capacity, &scapa);
 		if (rc != EOK) {
 			printf("Out of memory.\n");
@@ -1016,7 +1016,7 @@
 
 		if (linfo.ltype == lt_none)
-			printf("Entire disk: %s %s", label, scap);
+			printf("Entire disk: %s %s", label, scapa);
 		else
-			printf("Partition %d: %s %s", npart, label, scap);
+			printf("Partition %d: %s %s", npart, label, scapa);
 
 		if ((linfo.flags & lf_ext_supp) != 0) {
@@ -1037,6 +1037,6 @@
 		printf("\n");
 
-		free(scap);
-		scap = NULL;
+		free(scapa);
+		scapa = NULL;
 		free(sfstype);
 		sfstype = NULL;
@@ -1047,5 +1047,5 @@
 	/* Display available space */
 	if ((linfo.flags & lf_can_create_pri) != 0) {
-		rc = fdisk_part_get_max_avail(dev, spc_pri, &mcap);
+		rc = fdisk_part_get_max_avail(dev, spc_pri, &mcapa);
 		if (rc != EOK) {
 			rc = EIO;
@@ -1053,7 +1053,7 @@
 		}
 
-		cap_simplify(&mcap);
-
-		rc = cap_format(&mcap, &smcap);
+		capa_simplify(&mcapa);
+
+		rc = capa_format(&mcapa, &smcapa);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -1062,12 +1062,12 @@
 
 		if ((linfo.flags & lf_ext_supp) != 0)
-			printf("Maximum free primary block: %s\n", smcap);
+			printf("Maximum free primary block: %s\n", smcapa);
 		else
-			printf("Maximum free block: %s\n", smcap);
-
-		free(smcap);
-		smcap = NULL;
-
-		rc = fdisk_part_get_tot_avail(dev, spc_pri, &mcap);
+			printf("Maximum free block: %s\n", smcapa);
+
+		free(smcapa);
+		smcapa = NULL;
+
+		rc = fdisk_part_get_tot_avail(dev, spc_pri, &mcapa);
 		if (rc != EOK) {
 			rc = EIO;
@@ -1075,7 +1075,7 @@
 		}
 
-		cap_simplify(&mcap);
-
-		rc = cap_format(&mcap, &smcap);
+		capa_simplify(&mcapa);
+
+		rc = capa_format(&mcapa, &smcapa);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -1084,15 +1084,15 @@
 
 		if ((linfo.flags & lf_ext_supp) != 0)
-			printf("Total free primary space: %s\n", smcap);
+			printf("Total free primary space: %s\n", smcapa);
 		else
-			printf("Total free space: %s\n", smcap);
-
-		free(smcap);
-		smcap = NULL;
+			printf("Total free space: %s\n", smcapa);
+
+		free(smcapa);
+		smcapa = NULL;
 	}
 
 	/* Display available space */
 	if ((linfo.flags & lf_can_create_log) != 0) {
-		rc = fdisk_part_get_max_avail(dev, spc_log, &mcap);
+		rc = fdisk_part_get_max_avail(dev, spc_log, &mcapa);
 		if (rc != EOK) {
 			rc = EIO;
@@ -1100,7 +1100,7 @@
 		}
 
-		cap_simplify(&mcap);
-
-		rc = cap_format(&mcap, &smcap);
+		capa_simplify(&mcapa);
+
+		rc = capa_format(&mcapa, &smcapa);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -1108,9 +1108,9 @@
 		}
 
-		printf("Maximum free logical block: %s\n", smcap);
-		free(smcap);
-		smcap = NULL;
-
-		rc = fdisk_part_get_tot_avail(dev, spc_log, &mcap);
+		printf("Maximum free logical block: %s\n", smcapa);
+		free(smcapa);
+		smcapa = NULL;
+
+		rc = fdisk_part_get_tot_avail(dev, spc_log, &mcapa);
 		if (rc != EOK) {
 			rc = EIO;
@@ -1118,7 +1118,7 @@
 		}
 
-		cap_simplify(&mcap);
-
-		rc = cap_format(&mcap, &smcap);
+		capa_simplify(&mcapa);
+
+		rc = capa_format(&mcapa, &smcapa);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -1126,7 +1126,7 @@
 		}
 
-		printf("Total free logical space: %s\n", smcap);
-		free(smcap);
-		smcap = NULL;
+		printf("Total free logical space: %s\n", smcapa);
+		free(smcapa);
+		smcapa = NULL;
 	}
 
@@ -1279,7 +1279,7 @@
 	return EOK;
 error:
-	free(sdcap);
-	free(scap);
-	free(smcap);
+	free(sdcapa);
+	free(scapa);
+	free(smcapa);
 	free(sfstype);
 	free(svcname);