Index: uspace/lib/c/generic/async/client.c
===================================================================
--- uspace/lib/c/generic/async/client.c	(revision 3679f51aebe627821a6aa4bbaf7cce97a839ef82)
+++ uspace/lib/c/generic/async/client.c	(revision 95838f1a8f08943888c243d9f9943a42487d903e)
@@ -243,5 +243,5 @@
 	assert(arg);
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	amsg_t *msg = (amsg_t *) arg;
@@ -268,5 +268,5 @@
 	}
 
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 }
 
@@ -357,5 +357,5 @@
 	amsg_t *msg = (amsg_t *) amsgid;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	assert(!msg->forget);
@@ -363,5 +363,5 @@
 
 	if (msg->done) {
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 		goto done;
 	}
@@ -403,5 +403,5 @@
 	amsg_t *msg = (amsg_t *) amsgid;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	assert(!msg->forget);
@@ -409,5 +409,5 @@
 
 	if (msg->done) {
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 		goto done;
 	}
@@ -477,5 +477,5 @@
 	assert(!msg->destroyed);
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	if (msg->done) {
@@ -486,5 +486,5 @@
 	}
 
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 }
 
@@ -506,5 +506,5 @@
 	tv_add_diff(&awaiter.to_event.expires, timeout);
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	async_insert_timeout(&awaiter);
Index: uspace/lib/c/generic/async/server.c
===================================================================
--- uspace/lib/c/generic/async/server.c	(revision 3679f51aebe627821a6aa4bbaf7cce97a839ef82)
+++ uspace/lib/c/generic/async/server.c	(revision 95838f1a8f08943888c243d9f9943a42487d903e)
@@ -432,10 +432,10 @@
 	 * Remove myself from the connection hash table.
 	 */
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	hash_table_remove(&conn_hash_table, &(conn_key_t){
 		.task_id = fibril_connection->in_task_id,
 		.phone_hash = fibril_connection->in_phone_hash
 	});
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	/*
@@ -520,7 +520,7 @@
 	/* Add connection to the connection hash table */
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	hash_table_insert(&conn_hash_table, &conn->link);
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	fibril_add_ready(conn->wdata.fid);
@@ -648,5 +648,5 @@
 	assert(call);
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	ht_link_t *link = hash_table_find(&conn_hash_table, &(conn_key_t){
@@ -655,5 +655,5 @@
 	});
 	if (!link) {
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 		return false;
 	}
@@ -663,5 +663,5 @@
 	msg_t *msg = malloc(sizeof(*msg));
 	if (!msg) {
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 		return false;
 	}
@@ -687,5 +687,5 @@
 	}
 
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 	return true;
 }
@@ -962,5 +962,5 @@
 	connection_t *conn = fibril_connection;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	if (usecs) {
@@ -982,5 +982,5 @@
 			memset(call, 0, sizeof(ipc_call_t));
 			IPC_SET_IMETHOD(*call, IPC_M_PHONE_HUNGUP);
-			futex_up(&async_futex);
+			futex_unlock(&async_futex);
 			return conn->close_chandle;
 		}
@@ -1003,9 +1003,9 @@
 		 * Get it again.
 		 */
-		futex_down(&async_futex);
+		futex_lock(&async_futex);
 		if ((usecs) && (conn->wdata.to_event.occurred) &&
 		    (list_empty(&conn->msg_queue))) {
 			/* If we timed out -> exit */
-			futex_up(&async_futex);
+			futex_unlock(&async_futex);
 			return CAP_NIL;
 		}
@@ -1020,5 +1020,5 @@
 	free(msg);
 
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 	return chandle;
 }
@@ -1106,5 +1106,5 @@
 	getuptime(&tv);
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 
 	link_t *cur = list_first(&timeout_list);
@@ -1132,5 +1132,5 @@
 	}
 
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 }
 
@@ -1144,5 +1144,5 @@
 	while (true) {
 		if (fibril_switch(FIBRIL_FROM_MANAGER)) {
-			futex_up(&async_futex);
+			futex_unlock(&async_futex);
 			/*
 			 * async_futex is always held when entering a manager
@@ -1152,5 +1152,5 @@
 		}
 
-		futex_down(&async_futex);
+		futex_lock(&async_futex);
 
 		suseconds_t timeout;
@@ -1164,5 +1164,5 @@
 
 			if (tv_gteq(&tv, &waiter->to_event.expires)) {
-				futex_up(&async_futex);
+				futex_unlock(&async_futex);
 				handle_expired_timeouts();
 				/*
@@ -1182,8 +1182,8 @@
 				timeout = tv_sub_diff(&waiter->to_event.expires,
 				    &tv);
-				futex_up(&async_futex);
+				futex_unlock(&async_futex);
 			}
 		} else {
-			futex_up(&async_futex);
+			futex_unlock(&async_futex);
 			timeout = SYNCH_NO_TIMEOUT;
 		}
@@ -1226,5 +1226,5 @@
 static errno_t async_manager_fibril(void *arg)
 {
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	/*
@@ -1887,5 +1887,5 @@
 _Noreturn void async_manager(void)
 {
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	fibril_switch(FIBRIL_FROM_DEAD);
 	__builtin_unreachable();
Index: uspace/lib/c/generic/fibril.c
===================================================================
--- uspace/lib/c/generic/fibril.c	(revision 3679f51aebe627821a6aa4bbaf7cce97a839ef82)
+++ uspace/lib/c/generic/fibril.c	(revision 95838f1a8f08943888c243d9f9943a42487d903e)
@@ -79,5 +79,5 @@
 	fibril->retval = fibril->func(fibril->arg);
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	fibril_switch(FIBRIL_FROM_DEAD);
 	/* Not reached */
Index: uspace/lib/c/generic/fibril_synch.c
===================================================================
--- uspace/lib/c/generic/fibril_synch.c	(revision 3679f51aebe627821a6aa4bbaf7cce97a839ef82)
+++ uspace/lib/c/generic/fibril_synch.c	(revision 95838f1a8f08943888c243d9f9943a42487d903e)
@@ -106,5 +106,5 @@
 	fibril_t *f = (fibril_t *) fibril_get_id();
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (fm->counter-- <= 0) {
 		awaiter_t wdata;
@@ -119,5 +119,5 @@
 	} else {
 		fm->oi.owned_by = f;
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 	}
 }
@@ -127,5 +127,5 @@
 	bool locked = false;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (fm->counter > 0) {
 		fm->counter--;
@@ -133,5 +133,5 @@
 		locked = true;
 	}
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	return locked;
@@ -166,7 +166,7 @@
 {
 	assert(fibril_mutex_is_locked(fm));
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	_fibril_mutex_unlock_unsafe(fm);
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 }
 
@@ -175,8 +175,8 @@
 	bool locked = false;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (fm->counter <= 0)
 		locked = true;
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	return locked;
@@ -195,5 +195,5 @@
 	fibril_t *f = (fibril_t *) fibril_get_id();
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (frw->writers) {
 		awaiter_t wdata;
@@ -211,5 +211,5 @@
 		if (frw->readers++ == 0)
 			frw->oi.owned_by = f;
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 	}
 }
@@ -219,5 +219,5 @@
 	fibril_t *f = (fibril_t *) fibril_get_id();
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (frw->writers || frw->readers) {
 		awaiter_t wdata;
@@ -234,5 +234,5 @@
 		frw->oi.owned_by = f;
 		frw->writers++;
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 	}
 }
@@ -240,5 +240,5 @@
 static void _fibril_rwlock_common_unlock(fibril_rwlock_t *frw)
 {
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (frw->readers) {
 		if (--frw->readers) {
@@ -301,5 +301,5 @@
 	}
 out:
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 }
 
@@ -320,8 +320,8 @@
 	bool locked = false;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (frw->readers)
 		locked = true;
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	return locked;
@@ -332,10 +332,10 @@
 	bool locked = false;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (frw->writers) {
 		assert(frw->writers == 1);
 		locked = true;
 	}
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	return locked;
@@ -369,5 +369,5 @@
 	wdata.wu_event.inlist = true;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (timeout) {
 		getuptime(&wdata.to_event.expires);
@@ -381,10 +381,10 @@
 
 	/* async_futex not held after fibril_switch() */
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	if (wdata.to_event.inlist)
 		list_remove(&wdata.to_event.link);
 	if (wdata.wu_event.inlist)
 		list_remove(&wdata.wu_event.link);
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	return wdata.to_event.occurred ? ETIMEOUT : EOK;
@@ -404,5 +404,5 @@
 	awaiter_t *wdp;
 
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	while (!list_empty(&fcv->waiters)) {
 		tmp = list_first(&fcv->waiters);
@@ -418,5 +418,5 @@
 		}
 	}
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 }
 
@@ -657,9 +657,9 @@
 void fibril_semaphore_up(fibril_semaphore_t *sem)
 {
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	sem->count++;
 
 	if (sem->count > 0) {
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 		return;
 	}
@@ -669,5 +669,5 @@
 	list_remove(tmp);
 
-	futex_up(&async_futex);
+	futex_unlock(&async_futex);
 
 	awaiter_t *wdp = list_get_instance(tmp, awaiter_t, wu_event.link);
@@ -685,9 +685,9 @@
 void fibril_semaphore_down(fibril_semaphore_t *sem)
 {
-	futex_down(&async_futex);
+	futex_lock(&async_futex);
 	sem->count--;
 
 	if (sem->count >= 0) {
-		futex_up(&async_futex);
+		futex_unlock(&async_futex);
 		return;
 	}